## postgres-xc 1.0.0

=== src/backend/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for the postgres backend
#
# Portions Copyright (c) 1996-2011, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/backend/Makefile
#
#-------------------------------------------------------------------------

PGFILEDESC = "PostgreSQL Server"
# This is a daemon process, which is why it is not labeled as an executable
#PGAPPICON=win32

subdir = src/backend
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

SUBDIRS = access bootstrap catalog parser commands executor foreign lib libpq \
	pgxc main nodes optimizer port postmaster regex replication rewrite \
	storage tcop tsearch utils $(top_builddir)/src/timezone $(top_builddir)/src/interfaces/libpq

include $(srcdir)/common.mk

# As of 1/2010:
# The probes.o file is necessary for dtrace support on Solaris, and on recent
# versions of systemtap.  (Older systemtap releases just produce an empty
# file, but that's okay.)  However, OS X's dtrace doesn't use it and doesn't
# even recognize the -G option.  So, build probes.o except on Darwin.
# This might need adjustment as other platforms add dtrace support.
ifneq ($(PORTNAME), darwin)
ifeq ($(enable_dtrace), yes)
LOCALOBJS += utils/probes.o
endif
endif

OBJS = $(SUBDIROBJS) $(LOCALOBJS) \
	$(top_builddir)/src/interfaces/libpq/fe-connect.o \
	$(top_builddir)/src/interfaces/libpq/fe-secure.o \
	$(top_builddir)/src/interfaces/libpq/fe-misc.o \
	$(top_builddir)/src/interfaces/libpq/fe-protocol3.o \
	$(top_builddir)/src/interfaces/libpq/fe-protocol2.o \
	$(top_builddir)/src/interfaces/libpq/fe-exec.o \
	$(top_builddir)/src/interfaces/libpq/fe-auth.o \
	$(top_builddir)/src/interfaces/libpq/pqexpbuffer.o \
	$(top_builddir)/src/port/libpgport_srv.a \
	$(top_builddir)/src/gtm/client/libgtmclient.a \
	$(top_builddir)/src/gtm/common/libgtm.a \
	$(top_builddir)/src/gtm/libpq/libpqcomm.a	

# We put libpgport into OBJS, so remove it from LIBS; also add libldap
LIBS := $(filter-out -lpgport, $(LIBS)) $(LDAP_LIBS_BE)

# The backend doesn't need everything that's in LIBS, however
LIBS := $(filter-out -lz -lreadline -ledit -ltermcap -lncurses -lcurses, $(LIBS))

# LIBS := $(LIBS) -lpqcomm
# LDFLAGS += -L$(top_builddir)/src/gtm/libpg
##########################################################################

all: submake-libpgport submake-schemapg postgres $(POSTGRES_IMP)

ifneq ($(PORTNAME), cygwin)
ifneq ($(PORTNAME), win32)
ifneq ($(PORTNAME), aix)

postgres: $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -L$(top_builddir)/src/gtm/libpg $(export_dynamic) $(call expand_subsys,$^) $(LIBS) -o $@

endif
endif
endif

ifeq ($(PORTNAME), cygwin)

postgres: $(OBJS) postgres.def libpostgres.a
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack,$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # cygwin

ifeq ($(PORTNAME), win32)
LIBS += -lsecur32

postgres: $(OBJS) postgres.def libpostgres.a $(WIN32RES)
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack=$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # win32

ifeq ($(PORTNAME), aix)

postgres: $(POSTGRES_IMP)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$(OBJS)) -Wl,-bE:$(top_builddir)/src/backend/$(POSTGRES_IMP) $(LIBS) -o $@

$(POSTGRES_IMP): $(OBJS)
	$(LD) $(LDREL) $(LDOUT) SUBSYS.o $(call expand_subsys,$^)
ifeq ($(host_os), aix3.2.5)
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
ifneq (,$(findstring aix4.1, $(host_os)))
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
	$(MKLDEXPORT) SUBSYS.o . > $@
endif
endif
	@rm -f SUBSYS.o

endif # aix

# Update the commonly used headers before building the subdirectories
$(SUBDIRS:%=%-recursive): $(top_builddir)/src/include/parser/gram.h $(top_builddir)/src/include/catalog/schemapg.h $(top_builddir)/src/include/utils/fmgroids.h $(top_builddir)/src/include/utils/errcodes.h $(top_builddir)/src/include/utils/probes.h

# run this unconditionally to avoid needing to know its dependencies here:
submake-schemapg:
	$(MAKE) -C catalog schemapg.h

# src/port needs a convenient way to force errcodes.h to get built
submake-errcodes: $(top_builddir)/src/include/utils/errcodes.h

.PHONY: submake-schemapg submake-errcodes

catalog/schemapg.h: | submake-schemapg

$(top_builddir)/src/port/libpgport_srv.a: | submake-libpgport


# The postgres.o target is needed by the rule in Makefile.global that
# creates the exports file when MAKE_EXPORTS = true.
postgres.o: $(OBJS)
	$(CC) $(LDREL) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$^) $(LIBS) -o $@


# The following targets are specified in make commands that appear in
# the make files in our subdirectories. Note that it's important we
# match the dependencies shown in the subdirectory makefiles!

parser/gram.h: parser/gram.y
	$(MAKE) -C parser gram.h

utils/fmgroids.h: utils/Gen_fmgrtab.pl catalog/Catalog.pm $(top_srcdir)/src/include/catalog/pg_proc.h
	$(MAKE) -C utils fmgroids.h

utils/errcodes.h: utils/generate-errcodes.pl utils/errcodes.txt
	$(MAKE) -C utils errcodes.h

utils/probes.h: utils/probes.d
	$(MAKE) -C utils probes.h

# Make symlinks for these headers in the include directory. That way
# we can cut down on the -I options. Also, a symlink is automatically
# up to date when we update the base file.
#
# The point of the prereqdir incantation in some of the rules below is to
# force the symlink to use an absolute path rather than a relative path.
# For headers which are generated by make distprep, the actual header within
# src/backend will be in the source tree, while the symlink in src/include
# will be in the build tree, so a simple ../.. reference won't work.
# For headers generated during regular builds, we prefer a relative symlink.

$(top_builddir)/src/include/parser/gram.h: parser/gram.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/catalog/schemapg.h: catalog/schemapg.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/errcodes.h: utils/errcodes.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/fmgroids.h: utils/fmgroids.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/probes.h: utils/probes.h
	cd '$(dir $@)' && rm -f $(notdir $@) && \
	    $(LN_S) "../../../$(subdir)/utils/probes.h" .


utils/probes.o: utils/probes.d $(SUBDIROBJS)
	$(DTRACE) $(DTRACEFLAGS) -C -G -s $(call expand_subsys,$^) -o $@


##########################################################################

# Be sure that these files get removed by the maintainer-clean target
distprep:
	$(MAKE) -C parser	gram.c gram.h scan.c
	$(MAKE) -C bootstrap	bootparse.c bootscanner.c
	$(MAKE) -C catalog	schemapg.h postgres.bki postgres.description postgres.shdescription
	$(MAKE) -C replication	repl_gram.c repl_scanner.c
	$(MAKE) -C utils	fmgrtab.c fmgroids.h errcodes.h
	$(MAKE) -C utils/misc	guc-file.c


##########################################################################

install: all installdirs install-bin
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog install-data
	$(MAKE) -C tsearch install-data
	$(INSTALL_DATA) $(srcdir)/libpq/pg_hba.conf.sample '$(DESTDIR)$(datadir)/pg_hba.conf.sample'
	$(INSTALL_DATA) $(srcdir)/libpq/pg_ident.conf.sample '$(DESTDIR)$(datadir)/pg_ident.conf.sample'
	$(INSTALL_DATA) $(srcdir)/utils/misc/postgresql.conf.sample '$(DESTDIR)$(datadir)/postgresql.conf.sample'
	$(INSTALL_DATA) $(srcdir)/access/transam/recovery.conf.sample '$(DESTDIR)$(datadir)/recovery.conf.sample'

install-bin: postgres $(POSTGRES_IMP) installdirs
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postgres$(X)'
ifneq ($(PORTNAME), win32)
	@rm -f '$(DESTDIR)$(bindir)/postmaster$(X)'
	ln -s postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
else
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
endif
ifeq ($(MAKE_EXPORTS), true)
	$(INSTALL_DATA) $(POSTGRES_IMP) '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
endif

.PHONY: install-bin

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)' '$(DESTDIR)$(datadir)'
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(MAKE_EXPORTS), true)
	$(MKDIR_P) '$(DESTDIR)$(pkglibdir)'
endif


##########################################################################

uninstall:
	rm -f '$(DESTDIR)$(bindir)/postgres$(X)' '$(DESTDIR)$(bindir)/postmaster'
ifeq ($(MAKE_EXPORTS), true)
	rm -f '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
endif
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog uninstall-data
	$(MAKE) -C tsearch uninstall-data
	rm -f '$(DESTDIR)$(datadir)/pg_hba.conf.sample' \
	      '$(DESTDIR)$(datadir)/pg_ident.conf.sample' \
	      '$(DESTDIR)$(datadir)/postgresql.conf.sample' \
	      '$(DESTDIR)$(datadir)/recovery.conf.sample'


##########################################################################

clean:
	rm -f $(LOCALOBJS) postgres$(X) $(POSTGRES_IMP) \
		$(top_builddir)/src/include/parser/gram.h \
		$(top_builddir)/src/include/catalog/schemapg.h \
		$(top_builddir)/src/include/utils/fmgroids.h \
		$(top_builddir)/src/include/utils/probes.h
ifeq ($(PORTNAME), cygwin)
	rm -f postgres.dll postgres.def libpostgres.a
endif
ifeq ($(PORTNAME), win32)
	rm -f postgres.dll postgres.def libpostgres.a $(WIN32RES)
endif

distclean: clean
	rm -f port/tas.s port/dynloader.c port/pg_sema.c port/pg_shmem.c \
	      port/pg_latch.c

maintainer-clean: distclean
	rm -f bootstrap/bootparse.c \
	      bootstrap/bootscanner.c \
	      parser/gram.c \
	      parser/gram.h \
	      parser/scan.c \
	      catalog/schemapg.h \
	      catalog/postgres.bki \
	      catalog/postgres.description \
	      catalog/postgres.shdescription \
	      replication/repl_gram.c \
	      replication/repl_gram.h \
	      replication/repl_scanner.c \
	      utils/fmgroids.h \
	      utils/fmgrtab.c \
	      utils/errcodes.h \
	      utils/misc/guc-file.c


##########################################################################
#

=== src/gtm/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/Makefile
#
#-----------------------------------------------------------------------------
PGFILEDESC = "gtm - Global Transaction Manager for Postgres-XC"
subdir = src/gtm
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

WANTED_DIRS=common path libpq client recovery main proxy gtm_ctl

all:
	@for dir in $(WANTED_DIRS); do \
        $(MAKE) -C $$dir $@ || exit; \
    done

clobber:
	@for dir in $(WANTED_DIRS); do \
        $(MAKE) -C $$dir $@ || exit; \
    done

clean:
	@for dir in $(WANTED_DIRS); do \
        $(MAKE) -C $$dir $@ || exit; \
    done

distclean: clean

maintainer-clean: distclean

install: all 
	$(INSTALL_PROGRAM) main/gtm$(X) '$(DESTDIR)$(bindir)/gtm$(X)'
	$(INSTALL_PROGRAM) gtm_ctl/gtm_ctl$(X) '$(DESTDIR)$(bindir)/gtm_ctl$(X)'
	$(INSTALL_PROGRAM) proxy/gtm_proxy$(X) '$(DESTDIR)$(bindir)/gtm_proxy$(X)'
	$(INSTALL_DATA) $(srcdir)/main/gtm.conf.sample '$(DESTDIR)$(datadir)/gtm.conf.sample'
	$(INSTALL_DATA) $(srcdir)/proxy/gtm_proxy.conf.sample '$(DESTDIR)$(datadir)/gtm_proxy.conf.sample'

uninstall:
	rm -f $(DESTDIR)$(bindir)/gtm$(X)
	rm -f $(DESTDIR)$(bindir)/gtm_ctl$(X)
	rm -f $(DESTDIR)$(bindir)/gtm_proxy$(X)
	rm -f $(DESTDIR)$(datadir)/gtm.conf.sample
	rm -f $(DESTDIR)$(datadir)/gtm_proxy.conf.sample

=== src/include/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/include
#
# 'make install' installs whole contents of src/include.
#
# src/include/Makefile
#
#-------------------------------------------------------------------------

subdir = src/include
top_builddir = ../..
include $(top_builddir)/src/Makefile.global


all: pg_config.h pg_config_os.h


# Subdirectories containing headers for server-side dev
SUBDIRS = access bootstrap catalog commands executor foreign lib libpq mb \
	nodes optimizer parser pgxc postmaster regex replication rewrite storage \
	snowball snowball/libstemmer tsearch tsearch/dicts utils \
	tcop snowball snowball/libstemmer tsearch tsearch/dicts utils \
	port port/win32 port/win32_msvc port/win32_msvc/sys \
	port/win32/arpa port/win32/netinet port/win32/sys \
	portability

# Install all headers
install: all installdirs
# These headers are needed by the public headers of the interfaces.
	$(INSTALL_DATA) $(srcdir)/postgres_ext.h   '$(DESTDIR)$(includedir)'
	$(INSTALL_DATA) $(srcdir)/libpq/libpq-fs.h '$(DESTDIR)$(includedir)/libpq'
	$(INSTALL_DATA) pg_config.h    '$(DESTDIR)$(includedir)'
	$(INSTALL_DATA) pg_config_os.h '$(DESTDIR)$(includedir)'
	$(INSTALL_DATA) $(srcdir)/pg_config_manual.h '$(DESTDIR)$(includedir)'
# These headers are needed by the not-so-public headers of the interfaces.
	$(INSTALL_DATA) $(srcdir)/c.h            '$(DESTDIR)$(includedir_internal)'
	$(INSTALL_DATA) $(srcdir)/port.h         '$(DESTDIR)$(includedir_internal)'
	$(INSTALL_DATA) $(srcdir)/postgres_fe.h  '$(DESTDIR)$(includedir_internal)'
	$(INSTALL_DATA) $(srcdir)/libpq/pqcomm.h '$(DESTDIR)$(includedir_internal)/libpq'
# These headers are needed for server-side development
	$(INSTALL_DATA) pg_config.h    '$(DESTDIR)$(includedir_server)'
	$(INSTALL_DATA) pg_config_os.h '$(DESTDIR)$(includedir_server)'
	$(INSTALL_DATA) utils/errcodes.h '$(DESTDIR)$(includedir_server)/utils'
	$(INSTALL_DATA) utils/fmgroids.h '$(DESTDIR)$(includedir_server)/utils'
# We don't use INSTALL_DATA for performance reasons --- there are a lot of files
	cp $(srcdir)/*.h '$(DESTDIR)$(includedir_server)'/ || exit; \
	chmod $(INSTALL_DATA_MODE) '$(DESTDIR)$(includedir_server)'/*.h  || exit; \
	for dir in $(SUBDIRS); do \
	  cp $(srcdir)/$$dir/*.h '$(DESTDIR)$(includedir_server)'/$$dir/ || exit; \
	  chmod $(INSTALL_DATA_MODE) '$(DESTDIR)$(includedir_server)'/$$dir/*.h  || exit; \
	done
ifeq ($(vpath_build),yes)
	for file in dynloader.h catalog/schemapg.h parser/gram.h utils/probes.h; do \
	  cp $$file '$(DESTDIR)$(includedir_server)'/$$file || exit; \
	  chmod $(INSTALL_DATA_MODE) '$(DESTDIR)$(includedir_server)'/$$file || exit; \
	done
endif

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(includedir)/libpq' '$(DESTDIR)$(includedir_internal)/libpq'
	$(MKDIR_P) $(addprefix '$(DESTDIR)$(includedir_server)'/, $(SUBDIRS))


uninstall:
	rm -f $(addprefix '$(DESTDIR)$(includedir)'/, pg_config.h pg_config_os.h pg_config_manual.h postgres_ext.h libpq/libpq-fs.h)
	rm -f $(addprefix '$(DESTDIR)$(includedir_internal)'/, c.h port.h postgres_fe.h libpq/pqcomm.h)
# heuristic...
	rm -rf $(addprefix '$(DESTDIR)$(includedir_server)'/, $(SUBDIRS) *.h)


clean:
	rm -f utils/fmgroids.h utils/errcodes.h parser/gram.h utils/probes.h catalog/schemapg.h

distclean maintainer-clean: clean
	rm -f pg_config.h dynloader.h pg_config_os.h stamp-h

maintainer-check:
	cd catalog && ./duplicate_oids

=== doc-xc/src/sgml/Makefile ===
#----------------------------------------------------------------------------
#
# PostgreSQL documentation makefile
#
# doc/src/sgml/Makefile
#
#----------------------------------------------------------------------------

# This makefile is for building and installing the documentation.
# When a release tarball is created, the documentation files are
# prepared using the distprep target.  In Git-based trees these files
# don't exist, unless explicitly built, so we skip the installation in
# that case.


# Make "html" the default target, since that is what most people tend
# to want to use.
html:

subdir = doc-xc/src/sgml
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

MAKESGMLDIR = $(top_builddir)/src/pgxc/tools/makesgml
MAKESGML = $(MAKESGMLDIR)/makesgml


all: html man

distprep: html distprep-man


ifndef COLLATEINDEX
COLLATEINDEX = $(DOCBOOKSTYLE)/bin/collateindex.pl
endif

ifndef JADE
JADE = jade
endif
SGMLINCLUDE = -D . -D $(srcdir)

ifndef NSGMLS
NSGMLS = nsgmls
endif

ifndef OSX
OSX = osx
endif

ifndef XSLTPROC
XSLTPROC = xsltproc
endif

VERSION = 1.0.0

override XSLTPROCFLAGS += --stringparam pg.version '$(VERSION)'


GENERATED_SGML = bookindex.sgml version.sgml \
	features-supported.sgml features-unsupported.sgml errcodes-table.sgml

ALLSGMLIN := $(wildcard $(srcdir)/*.sgmlin $(srcdir)/ref/*.sgmlin)

#ALLSGML := $(wildcard $(srcdir)/*.sgml $(srcdir)/ref/*.sgml) $(GENERATED_SGML)
ALLSGML := $(ALLSGMLIN:%sgmlin=%sgml) $(GENERATED_SGML)

ALLSGMLTOREMOVE := $(ALLSGMLIN:%sgmlin=%sgml)


# Sometimes we don't want this one.
ALMOSTALLSGML := $(filter-out %bookindex.sgml,$(ALLSGML))

ifdef DOCBOOKSTYLE
CATALOG = -c $(DOCBOOKSTYLE)/catalog
endif

# Enable some extra warnings
# -wfully-tagged needed to throw a warning on missing tags
# for older tool chains, 2007-08-31
# Note: try "make SPFLAGS=-wxml" to catch a lot of other dubious constructs,
# in particular < and & that haven't been made into entities.  It's far too
# noisy to turn on by default, unfortunately.
override SPFLAGS += -wall -wno-unused-param -wno-empty -wfully-tagged

##
## SGML files
##

sgml-files: $(ALLSGMLIN:%sgmlin=%sgml)

##
## Man pages
##

man distprep-man: man-stamp

man-stamp: stylesheet-man.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $(XSLTPROC_MAN_FLAGS) $^
	touch $@


##
## HTML
##

.PHONY: draft

JADE.html.call = $(JADE) $(JADEFLAGS) $(SPFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t sgml -i output-html

# The draft target creates HTML output in draft mode, without index (for faster build).
draft: postgres.sgml $(ALMOSTALLSGML) stylesheet.dsl
	$(MKDIR_P) html
	$(JADE.html.call) -V draft-mode $<
	cp $(srcdir)/stylesheet.css html/

html: html-stamp

html-stamp: postgres.sgml $(ALLSGML) stylesheet.dsl
	$(MKDIR_P) html
	$(JADE.html.call) -i include-index $<
	cp $(srcdir)/stylesheet.css html/
	touch $@

# single-page HTML
postgres.html: postgres.sgml $(ALLSGML) stylesheet.dsl
	$(JADE.html.call) -V nochunks -V rootchunk -V '(define %root-filename% #f)' -V '(define use-output-dir #f)' -i include-index $<

# single-page text
postgres.txt: postgres.html
	$(LYNX) -force_html -dump -nolist $< > $@

HTML.index: postgres.sgml $(ALMOSTALLSGML) stylesheet.dsl
	@$(MKDIR_P) html
	$(JADE.html.call) -V html-index $<

bookindex.sgml: HTML.index
	LC_ALL=C $(PERL) $(COLLATEINDEX) -f -g -i 'bookindex' -o $@ $<

# Technically, this should depend on Makefile.global, but then
# version.sgml would need to be rebuilt after every configure run,
# even in distribution tarballs.  So this is cheating a bit, but it
# will achieve the goal of updating the version number when it
# changes.
version.sgml: $(top_srcdir)/configure
	{ \
	  echo "<!ENTITY version \"$(VERSION)\">"; \
	  echo "<!ENTITY majorversion \"$(MAJORVERSION)\">"; \
	} > $@

features-supported.sgml: $(top_srcdir)/src/backend/catalog/sql_feature_packages.txt $(top_srcdir)/src/backend/catalog/sql_features.txt
	$(PERL) $(srcdir)/mk_feature_tables.pl YES $^ > $@

features-unsupported.sgml: $(top_srcdir)/src/backend/catalog/sql_feature_packages.txt $(top_srcdir)/src/backend/catalog/sql_features.txt
	$(PERL) $(srcdir)/mk_feature_tables.pl NO $^ > $@

errcodes-table.sgml: $(top_srcdir)/src/backend/utils/errcodes.txt generate-errcodes-table.pl
	$(PERL) $(srcdir)/generate-errcodes-table.pl $< > $@

##
## Print
##


# RTF to allow minor editing for hardcopy
%.rtf: %.sgml $(ALLSGML)
	$(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t rtf -V rtf-backend -i output-print  -i include-index postgres.sgml

# TeX
# Regular TeX and pdfTeX have slightly differing requirements, so we
# need to distinguish the path we're taking.

JADE.tex.call = $(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d $(srcdir)/stylesheet.dsl -t tex -V tex-backend -i output-print -i include-index

%-A4.tex-ps: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texdvi-output -V '%paper-type%'=A4 -o $@ $<

%-US.tex-ps: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texdvi-output -V '%paper-type%'=USletter -o $@ $<

%-A4.tex-pdf: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texpdf-output -V '%paper-type%'=A4 -o $@ $<

%-US.tex-pdf: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texpdf-output -V '%paper-type%'=USletter -o $@ $<

%.dvi: %.tex-ps
	@rm -f $*.aux $*.log
# multiple runs are necessary to create proper intra-document links
	jadetex $<
	jadetex $<
	jadetex $<

# PostScript from TeX
postgres.ps:
	$(error Invalid target;  use postgres-A4.ps or postgres-US.ps as targets)

%.ps: %.dvi
	dvips -o $@ $<

postgres.pdf:
	$(error Invalid target;  use postgres-A4.pdf or postgres-US.pdf as targets)

%.pdf: %.tex-pdf
	@rm -f $*.aux $*.log $*.out
# multiple runs are necessary to create proper intra-document links
	pdfjadetex $<
	pdfjadetex $<
	pdfjadetex $<

# Cancel built-in suffix rules, interfering with PS building
.SUFFIXES:
.SUFFIXES: .sgml .sgmlin

INC_LIST = -I PG -I EN
#INC_LIST = -I PGXC -I EN

.sgmlin.sgml:
	$(MAKE) -C $(MAKESGMLDIR)
	$(MAKESGML) -i $< -o $@ $(INC_LIST) $(EXC_LIST)


# This generates an XML version of the flow-object tree.  It's useful
# for debugging DSSSL code, and possibly to interface to some other
# tools that can make use of this.
%.fot: %.sgml $(ALLSGML)
	$(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t fot -i output-print -i include-index -o $@ $<


##
## Semi-automatic generation of some text files.
##

JADE.text = $(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -i output-text -t sgml
LYNX = lynx

INSTALL HISTORY regress_README: % : %.html
	$(PERL) -p -e 's/<H(1|2)$$/<H\1 align=center/g' $< | $(LYNX) -force_html -dump -nolist -stdin > $@

INSTALL.html: standalone-install.sgml installation.sgml version.sgml
	$(JADE.text) -V nochunks standalone-install.sgml installation.sgml > $@

HISTORY.html: generate_history.pl $(wildcard $(srcdir)/release*.sgml)
	$(PERL) $< "$(srcdir)" release.sgml >tempfile_HISTORY.sgml
	$(JADE.text) -V nochunks tempfile_HISTORY.sgml > $@
	rm tempfile_HISTORY.sgml

regress_README.html: regress.sgml
	( echo '<!DOCTYPE chapter PUBLIC "-//OASIS//DTD DocBook V4.2//EN" ['; \
	  echo '<!ENTITY % standalone-ignore "IGNORE">'; \
	  echo '<!ENTITY % standalone-include "INCLUDE"> ]>'; \
	  cat $< ) >tempfile_regress_README.sgml
	$(JADE.text) -V nochunks tempfile_regress_README.sgml > $@
	rm tempfile_regress_README.sgml


##
## XSLT processing
##

# For obscure reasons, gmake 3.81 complains about circular dependencies
# if we try to do "make all" in a VPATH build without the explicit
# $(srcdir) on the postgres.sgml dependency in this rule.  gmake bug?
postgres.xml: $(srcdir)/postgres.sgml $(ALMOSTALLSGML)
	$(OSX) -D. -x lower $< >postgres.xmltmp
	$(PERL) -p -e 's/\[(amp|copy|egrave|gt|lt|mdash|nbsp|ouml|pi|quot|uuml) *\]/\&\1;/g;' \
	           -e '$$_ .= qq{<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN" "http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd">\n} if $$. == 1;' \
	  <postgres.xmltmp > $@
	rm postgres.xmltmp
# ' hello Emacs

xslthtml: stylesheet.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $(XSLTPROC_HTML_FLAGS) $^

htmlhelp: stylesheet-hh.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $^

%-A4.fo: stylesheet-fo.xsl %.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) --stringparam paper.type A4 -o $@ $^

%-US.fo: stylesheet-fo.xsl %.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) --stringparam paper.type USletter -o $@ $^


##
## Experimental Texinfo targets
##

DB2X_TEXIXML = db2x_texixml
DB2X_XSLTPROC = db2x_xsltproc
MAKEINFO = makeinfo

%.texixml: %.xml
	$(DB2X_XSLTPROC) -s texi -g output-file=$(basename $@) $< -o $@

%.texi: %.texixml
	$(DB2X_TEXIXML) --encoding=iso-8859-1//TRANSLIT $< --to-stdout > $@

%.info: %.texi
	$(MAKEINFO) --enable-encoding --no-split --no-validate $< -o $@


##
## Check
##

# Quick syntax check without style processing
check maintainer-check: postgres.sgml $(ALMOSTALLSGML) check-tabs
	$(NSGMLS) $(SPFLAGS) $(SGMLINCLUDE) -s $<


##
## Install
##

install: install-html

ifneq ($(PORTNAME), sco)
install: install-man
endif

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(htmldir)'/html $(addprefix '$(DESTDIR)$(mandir)'/man, 1 3 $(sqlmansectnum))

uninstall:
	rm -f '$(DESTDIR)$(htmldir)/html/'* $(addprefix  '$(DESTDIR)$(mandir)'/man, 1/* 3/* $(sqlmansectnum)/*)


## Install html

install-html: html installdirs
	cp -R $(call vpathsearch,html) '$(DESTDIR)$(htmldir)'


## Install man

install-man: man installdirs

sqlmansect ?= 7
sqlmansectnum = $(shell expr X'$(sqlmansect)' : X'\([0-9]\)')

# Before we install the man pages, we massage the section numbers to
# follow the local conventions.
#
ifeq ($(sqlmansectnum),7)
install-man:
	cp -R $(foreach dir,man1 man3 man7,$(call vpathsearch,$(dir))) '$(DESTDIR)$(mandir)'

else # sqlmansectnum != 7
fix_sqlmansectnum = sed -e '/^\.TH/s/"7"/"$(sqlmansect)"/' \
			-e 's/\\fR(7)/\\fR($(sqlmansectnum))/g' \
			-e '1s/^\.so man7/.so man$(sqlmansectnum)/g;1s/^\(\.so.*\)\.7$$/\1.$(sqlmansect)/g'

man: fixed-man-stamp

fixed-man-stamp: man-stamp
	@$(MKDIR_P) $(addprefix fixedman/,man1 man3 man$(sqlmansectnum))
	for file in $(call vpathsearch,man1)/*.1; do $(fix_sqlmansectnum) $$file >fixedman/man1/`basename $$file` || exit; done
	for file in $(call vpathsearch,man3)/*.3; do $(fix_sqlmansectnum) $$file >fixedman/man3/`basename $$file` || exit; done
	for file in $(call vpathsearch,man7)/*.7; do $(fix_sqlmansectnum) $$file >fixedman/man$(sqlmansectnum)/`basename $$file | sed s/\.7$$/.$(sqlmansect)/` || exit; done

install-man:
	cp -R $(foreach dir,man1 man3 man$(sqlmansectnum),fixedman/$(dir)) '$(DESTDIR)$(mandir)'

clean: clean-man clean-sgml

.PHONY: clean-man
clean-man:
	rm -rf fixedman/ fixed-man-stamp

.PHONY: clean-sgml:
clean-sgml:
	rm -rf $(ALLSGML)

endif # sqlmansectnum != 7

# tabs are harmless, but it is best to avoid them in SGML files
check-tabs:
	@( ! grep '	' $(wildcard $(srcdir)/*.sgml $(srcdir)/ref/*.sgml) ) || (echo "Tabs appear in SGML files";  exit 1)

##
## Clean
##

# This allows removing some files from the distribution tarballs while
# keeping the dependencies satisfied.
.SECONDARY: postgres.xml $(GENERATED_SGML) HTML.index
.SECONDARY: INSTALL.html HISTORY.html regress_README.html
.SECONDARY: %-A4.tex-ps %-US.tex-ps %-A4.tex-pdf %-US.tex-pdf

clean:
# text --- these are shipped, but not in this directory
	rm -f INSTALL HISTORY regress_README
	rm -f INSTALL.html HISTORY.html regress_README.html
# single-page output
	rm -f postgres.html postgres.txt
# print
	rm -f *.rtf *.tex-ps *.tex-pdf *.dvi *.aux *.log *.ps *.pdf *.out *.fot
# index
	rm -f HTML.index $(GENERATED_SGML)
# XSLT
	rm -f postgres.xml postgres.xmltmp htmlhelp.hhp toc.hhc index.hhk *.fo
# Texinfo
	rm -f *.texixml *.texi *.info db2texi.refs

distclean: clean

maintainer-clean: distclean
# HTML
	rm -fr html/ html-stamp
# man
	rm -rf man1/ man3/ man7/ man-stamp
# sgml
	rm -f $(ALLSGMLTOREMOVE)

.PHONY: sgmlfiles

INC_LIST = -I XC -I EN
EXC_LIST = -E PG -E JP

sgmlfiles:
	./makesgmlfiles $(INC_LIST) $(EXC_LIST)

=== src/backend/pgxc/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC backend method makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/backend/pgxc/Makefile
#
#-----------------------------------------------------------------------------
subdir = src/backend/pgxc
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

SUBDIRS	    = locator plan pool barrier nodemgr xc_maintenance_mode

include $(top_srcdir)/src/backend/common.mk

=== src/gtm/client/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM client makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/client/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/client

NAME=gtmclient
SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

OBJS=fe-misc.o fe-connect.o pqexpbuffer.o ip.o strlcpy.o gtm_client.o fe-protocol.o
LDFLAGS=-L$(top_build_dir)/common -L$(top_build_dir)/libpq

LIBS=-lpthread

all:all-lib

include $(top_srcdir)/src/Makefile.shlib

clean:
	rm -f $(OBJS)
	rm -f libgtmclient.a libgtmclient.so libgtmclient.so.1 libgtmclient.so.1.0

distclean: clean

maintainer-clean: distclean

=== src/gtm/common/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM common makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/common/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
subdir=src/gtm/common

include $(top_builddir)/src/Makefile.global

override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)

NAME=gtm

SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq
LIBS=-lpthread

OBJS = gtm_opt_handler.o aset.o mcxt.o gtm_utils.o elog.o assert.o stringinfo.o gtm_lock.o \
       gtm_list.o gtm_serialize.o gtm_serialize_debug.o

all:all-lib

gtm_opt_handler.o: gtm_opt_scanner.c

gtm_opt_scanner.c: gtm_opt_scanner.l
ifdef FLEX
	$(FLEX) $(FLEXFLAGS) -o'$@' $<
else
	@$(missing) flex $< $@
endif

# Shared library stuff
include $(top_srcdir)/src/Makefile.shlib

# Note that gtm_opt_scanner.c is not deleted by make clean as we want it in distribution tarballs
clean:
	rm -f $(OBJS)
	rm -f libgtm.so libgtm.so.1 libgtm.so.1.0

distclean: clean

maintainer-clean: distclean

=== src/gtm/gtm_ctl/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM gtm_ctl makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/gtm_ctl/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/gtm_ctl

OBJS=gtm_ctl.o 

OTHERS=../common/libgtm.a ../libpq/libpqcomm.a ../client/libgtmclient.a ../path/libgtmpath.a

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq


LIBS=-lpthread

gtm_ctl:$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LIBS) $^ $(OTHERS) -o gtm_ctl

all:gtm_ctl

clean:
	rm -f $(OBJS)
	rm -f gtm_ctl

distclean: clean

maintainer-clean: distclean

=== src/gtm/libpq/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM libpq makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/libpq/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/libpq

NAME=pqcomm
SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

OBJS=ip.o pqcomm.o pqformat.o strlcpy.o pqsignal.o

all:all-lib

include $(top_srcdir)/src/Makefile.shlib

clean:
	rm -f $(OBJS)
	rm -f libpqcomm.so libpqcomm.so.1 libpqcomm.so.1.0 

distclean: clean

maintainer-clean: distclean

=== src/gtm/main/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM main Makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/main/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/main

ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

OBJS=main.o gtm_thread.o gtm_txn.o gtm_seq.o gtm_snap.o gtm_time.o gtm_standby.o gtm_opt.o

OTHERS= ../libpq/libpqcomm.a ../path/libgtmpath.a ../recovery/libgtmrecovery.a ../client/libgtmclient.a ../common/libgtm.a ../../port/libpgport.a 

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq

LIBS=-lpthread

gtm:$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LIBS) $^ $(OTHERS) -o gtm

all:gtm

clean:
	rm -f $(OBJS)
	rm -f gtm

distclean: clean

maintainer-clean: distclean

=== src/gtm/path/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM path makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/path/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/path

NAME=gtmpath
SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

OBJS=path.o

all:all-lib

include $(top_srcdir)/src/Makefile.shlib

clean:
	rm -f $(OBJS)
	rm -f libgtmpath.a libgtmpath.so libgtmpath.so.1 libgtmpath.so.1.0

distclean: clean

maintainer-clean: distclean

=== src/gtm/proxy/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM proxy Makefile
#
# Copyright(c) 2010-2012 Postgres-XC Development Group
#
# src/gtm/proxy/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/proxy

ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

OBJS=proxy_main.o proxy_thread.o proxy_utils.o gtm_proxy_opt.o

OTHERS= ../libpq/libpqcomm.a ../path/libgtmpath.a ../recovery/libgtmrecovery.a ../client/libgtmclient.a ../common/libgtm.a

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq

LIBS=-lpthread

gtm_proxy:$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LIBS) $^ $(OTHERS) ../../port/libpgport_srv.a -o gtm_proxy

all:gtm_proxy

clean:
	rm -f $(OBJS)
	rm -f gtm_proxy

distclean: clean

maintainer-clean: distclean

=== debian/changelog ===
postgres-xc (1.0.0-2) unstable; urgency=low

  [ Vladimir Stavrinov ]
  * Fix permissions for logrotate. Set PGDATABASE variable to postgres.
  * Minor bug fix: remove slashes before quotes.

  [ Michael Meskes ]
  * Removed redundant sudo call in postinst.
  * Added lintian override to not complain about seemingly missing ecpg man
    page. The manpage is in libecpg-dev which ecpg-xc depends on.
  * Do not bail out if server cannot be started in postinst. Admin may have
    disabled it for a reason. (Closes: #679714)
  * Fixed typo that made client package conflict with non-existant package.
    (Closes: #679858, #679859)
  * Added missing conflict for contrib package. (Closes: #679860)

 -- Michael Meskes <meskes@debian.org>  Mon, 02 Jul 2012 11:20:49 +0200

postgres-xc (1.0.0-1) unstable; urgency=low

  * Initial release (Closes: #646563)

 -- Michael Meskes <meskes@debian.org>  Tue, 19 Jun 2012 12:57:16 +0200

=== debian/control ===
Source: postgres-xc
Section: database
Priority: optional
Maintainer: Vladimir Stavrinov <vstavrinov@gmail.com>
Uploaders: Michael Meskes <meskes@debian.org>
Build-Depends: debhelper (>= 8.0.0),
 dpkg-dev (>= 1.16.1~) | hardening-wrapper,
 perl (>= 5.8),
 libperl-dev,
 libpq-dev,
 tcl8.5-dev,
 libedit-dev,
 libssl-dev, 
 zlib1g-dev | libz-dev,
 libpam0g-dev | libpam-dev,
 libxml2-dev, libkrb5-dev,
 libldap2-dev,
 libxslt1-dev,
 libossp-uuid-dev,
 python-dev,
 bison,
 flex,
 openjade,
 docbook-dsssl,
 docbook-xsl,
 opensp,
 xsltproc,
 gettext
Standards-Version: 3.9.3
Homepage: http://postgres-xc.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-postgresql/postgres-xc.git
Vcs-Browser: http://git.debian.org/?p=pkg-postgresql/postgres-xc.git

Package: postgres-xc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgres-xc-client,
 adduser, ssl-cert (>= 1.0.11), logrotate
Conflicts: postgresql-common
Description: write-scalable, synchronous multi-master, transparent PostgreSQL cluster
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.

Package: postgres-xc-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, postgres-xc (= ${binary:Version})
Description: debug symbols for postgres-xc
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.
 .
 This package provides detached debugging symbols for Postgres-XC.

Package: postgres-xc-doc
Section: doc
Priority: extra
Architecture: all
Depends: ${misc:Depends}
Description: documentation for the Postgres-XC cluster
 This package contains all README files, user manual, and examples for
 Postgres-XC. The manual is in HTML format.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-client
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Suggests: postgres-xc, postgresql-xc-doc
Conflicts: postgresql-client-common
Description: front-end programs for Postgres-XC
 This package contains client and administrative programs for
 Postgres-XC: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for Postgres-XC. If you install
 Postgres-XC on a standalone machine, you need the server package
 postgres-xc, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .  
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-server-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev (>= 9.1~)
Description: development files for Postgres-XC server-side programming
 Header files for compiling SSI code to link into Postgres-XC's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on 
 modules of Postgres-XC, which would otherwise have to be built in the
 Postgres-XC source-code tree.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plperl
Architecture: any
Depends: ${misc:Depends}, 
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version}),
 perl
Description: PL/Perl procedural language for Postgres-XC
 PL/Perl enables an SQL developer to write procedural language functions
 for Postgres-XC in Perl.  You need this package if you have any
 Postgres-XC functions that use the languages plperl or plperlu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plpython
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Python procedural language for Postgres-XC
 PL/Python enables an SQL developer to write procedural language functions
 for Postgres-XC in Python.  You need this package if you have any
 Postgres-XC functions that use the languages plpython or plpythonu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-pltcl
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Tcl procedural language for Postgres-XC
 PL/Tcl enables an SQL developer to write procedural language functions
 for Postgres-XC in Tcl.  You need this package if you have any
 Postgres-XC functions that use the languages pltcl or pltclu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-contrib
Architecture: any
Depends: postgres-xc (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: libdbd-pg-perl
Conflicts: postgresql-client-common
Description: additional facilities for Postgres-XC
 The Postgres-XC contrib package provides several additional features
 for the Postgres-XC database.  contrib often serves as a testbed for
 features before they are adopted into PostgreSQL proper:
 .
  adminpack      - File and log manipulation routines, used by pgAdmin
  btree_gist     - B-Tree indexing using GiST (Generalised Search Tree)
  chkpass        - An auto-encrypted password datatype
  cube           - Multidimensional-cube datatype (GiST indexing example)
  dblink         - Functions to return results from a remote database
  earthdistance  - Operator for computing the distance (in miles) between
                   two points on the earth's surface
  fuzzystrmatch  - Levenshtein, metaphone, and soundex fuzzy string matching
  hstore         - Store (key, value) pairs
  intagg         - Integer aggregator/enumerator
  _int           - Index support for arrays of int4, using GiST (benchmark
                   needs the libdbd-pg-perl package)
  isn            - type extensions for ISBN, ISSN, ISMN, EAN13 product numbers
  lo             - Large Object maintenance
  ltree          - Tree-like data structures
  oid2name       - Maps OIDs to table names
  pageinspect    - Inspection of database pages
  passwordcheck  - Simple password strength checker
  pg_buffercache - Real time queries on the shared buffer cache
  pg_freespacemap- Displays the contents of the free space map (FSM)
  pg_trgm        - Determine the similarity of text based on trigram matching
  pg_standby     - Create a warm stand-by server
  pgbench        - TPC-B like benchmark
  pgcrypto       - Cryptographic functions
  pgrowlocks     - A function to return row locking information
  pgstattuple    - Returns the percentage of dead tuples in a table; this
                   indicates whether a vacuum is required.
  seg            - Confidence-interval datatype (GiST indexing example)
  spi            - PostgreSQL Server Programming Interface; 4 examples of
                   its use:
                   autoinc    - A function for implementing AUTOINCREMENT/
                                IDENTITY
                   insert_username - function for inserting user names
                   moddatetime - Update modification timestamps
                   refint     - Functions for implementing referential
                                integrity (foreign keys).  Note that this is
                                now superseded by built-in referential
                                integrity.
                   timetravel - Re-implements in user code the time travel
                                feature that was removed in 6.3.
  tablefunc      - examples of functions returning tables
  uuid-ossp      - UUID generation functions
  vacuumlo       - Remove orphaned large objects
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: ecpg-xc
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev,
 libecpg-dev (>= 9.1~),
 libecpg6 (>= 9.1~),
 libecpg-compat3 (>= 9.1~),
 libpgtypes3 (>= 9.1~)
Description: Postgres-XC version of ECPG (Embedded PostgreSQL for C)
 This package contains the precompiler ECPG (Embedded
 PostgreSQL for C) for parsing Postgres-XC syntax. 
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.
 . 
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TCL_VER := 8.5

# support both hardening-wrapper (for backports) and dpkg-buildflags
export DEB_BUILD_HARDENING = 1
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
LDFLAGS+= -Wl,--as-needed -Wl,-z,now
CFLAGS+= -fPIC

# When protecting the postmaster with oom_adj=-17, allow the OOM killer to slay
# the backends (http://archives.postgresql.org/pgsql-hackers/2010-01/msg00170.php)
ifeq ($(shell uname -s),Linux)
CFLAGS+= -DLINUX_OOM_ADJ=0
endif

ifneq ($(findstring $(DEB_BUILD_ARCH), sparc alpha),)
# sparc and alpha's gcc currently miscompiles; see
# http://lists.debian.org/debian-alpha/2007/11/msg00025.html
    CFLAGS+=-O1
endif

# build should fail on test suite failures on all arches
TESTSUITE_FAIL_CMD=exit 1

override_dh_auto_clean:
	[ ! -f GNUmakefile ] || make distclean
	-rm -fr build
	-find doc-xc/src/sgml -name "*.sgml" -exec rm -f {} \;
	(cd src/test/regress/sql; \
	  rm -f misc.sql \
	  rm -f create_function_1.sql \
	  rm -f create_function_2.sql \
	  rm -f largeobject.sql \
	  rm -f copy.sql \
	  rm -f constraints.sql \
	  rm -f security_label.sql \
	  rm -f tablespace.sql \
	  rm -f xc_copy.sql)

override_dh_auto_configure:
	mkdir -p build
	cd build && ../configure --prefix=/usr \
		--libdir=/usr/lib/postgres-xc \
		--docdir=/usr/share/doc/postgres-xc-doc \
		--datarootdir=/usr/share \
		--datadir=/usr/share/postgres-xc \
		--includedir=/usr/include/postgres-xc \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--enable-nls \
		--enable-integer-datetimes \
		--enable-thread-safety \
		--enable-debug \
		--disable-maintainer-mode \
		--disable-dependency-tracking \
		--disable-rpath \
		--with-ossp-uuid \
		--with-gnu-ld \
		--with-pgport=5432 \
		--with-system-tzdata=/usr/share/zoneinfo \
		--with-tcl \
		--with-perl \
		--with-python \
		--with-pam \
		--with-krb5 \
		--with-gssapi \
		--with-openssl \
		--with-libxml \
		--with-libxslt \
		--with-ldap \
		--with-tclconfig=/usr/lib/tcl$(TCL_VER) \
		--with-tkconfig=/usr/lib/tk$(TCL_VER) \
		--with-includes=/usr/include/tcl$(TCL_VER) 

override_dh_auto_build:
	cd build && $(MAKE)

override_dh_auto_install:
	make -C build install-world DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install

	# these get installed into the individual -/l* packages; -f because it
	# does not exist for an -A build
	rm -f debian/postgres-xc-contrib/usr/share/postgres-xc/extension/pl*

override_dh_strip:
	dh_strip --dbg-package=postgres-xc-dbg

override_dh_auto_test:
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	# patch away the "don't execute as root" check for the test
	# suite; doing it here will ensure that the actual debs have
	# the check.
	set -e; \
	patch --no-backup-if-mismatch -p1 < debian/disable-root-check.patch; \
	patch --no-backup-if-mismatch -p1 < debian/pg_regress-in-tmp.patch; \
	#make -C build/src/test/regress bigcheck || fail=1; \
	patch --no-backup-if-mismatch -Rp1 < debian/pg_regress-in-tmp.patch; \
	patch --no-backup-if-mismatch -Rp1 < debian/disable-root-check.patch; \
	if [ -n "$$fail" ]; then \
	    for l in regression.diffs log/initdb.log log/postmaster.log; do \
	    	if [ -e build/src/test/regress/$$l ]; then \
		    echo "********* $$l *******"; \
		    cat build/src/test/regress/$$l; \
		fi; \
	    done; \
	    $(TESTSUITE_FAIL_CMD); \
	fi
endif

%:
	dh $@

=== debian/watch ===
version=3
opts="uversionmangle=s/beta/~beta/" \
http://sf.net/postgres-xc/pgxc_v(.+)\.tar\.gz
